C  1997/9
C          CALCULATE STRESS AND DISPLACEMENT
C   FOR TWO DIMENSIONAL FINIFTE ELEMENT F2D SOLUTION 
C          ------- F2DSD.FOR  FOR WINDOWS95 -------
C                   BY TAKAYUKI HIRAI 
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /A/RN22(8),H22(2,8),EE(3,3,300),BML(3,4),
     1          BMA(3,16),XGX(5),WGX(5),XY(16),SR(7),
     2          DF(16),UUN(4000,4),SSG(4000),EN(300),
     3          PR(300),GZ,EA,DET,X1,X2,U1,U2,NONC,M,
     4          MM,IDE,NGA,IRR
      COMMON /B/CO(2000,2),TH(300),X(20000),DU(20000),
     1          IP(300),MOU(2000,2),MV(9,4000)
      CHARACTER TITLE*40,C1*10
C
C  ------------------  INPUT DATA  --------------------
      OPEN(15,FILE='R1',STATUS='OLD')
      OPEN(16,FILE='SD')
      IRR=0
      DO 10 I=1,6
   10 READ(15,1009) C1
      READ(15,1001) TITLE 
      WRITE(*,2001) TITLE
      WRITE(16,2002) TITLE
      READ(15,1009) C1
      READ(15,1009) C1
      READ(15,1002) NELE,NODE,NODT,NMAT,NGA
      WRITE(16,2003) NELE,NODE,NODT,NMAT,NGA
      READ(15,1004) NONC
      WRITE(16,2004) NONC
      READ(15,1009) C1
      READ(15,1009) C1
      WRITE(16,2005)
      DO 16 I=1,NMAT
      READ(15,1006) II,EN(I),PR(I),TH(I),IP(I)
      WRITE(16,2006) II,EN(I),PR(I),TH(I),IP(I)
      IF(DABS(PR(I)**2-1.0).LT.0.0001) IRR=11000+I
      IF(IP(I).EQ.1) EN(I)=EN(I)/(1.0-PR(I)**2)
      IF(IP(I).EQ.1) PR(I)=PR(I)/(1.0-PR(I))
      IF(DABS(PR(I)**2-1.0).LT.0.0001) IRR=11000+I
      IF(IRR.NE.0) GO TO 43
      DO 17 J=1,2
      EE(3,J,I)=0.0
      EE(J,3,I)=0.0
   17 EE(J,J,I)=EN(I)/(1.0-PR(I)*PR(I))
      EE(1,2,I)=EN(I)*PR(I)/(1.0-PR(I)*PR(I))
      EE(2,1,I)=EE(1,2,I)
   16 EE(3,3,I)=EN(I)/(1.0+PR(I))/2.0
      READ(15,1009) C1
      READ(15,1009) C1
      DO 23 J=1,NELE
   23 READ(15,1007) MS,(MV(I,J),I=1,9),SSG(J)
      READ(15,1009) C1
      READ(15,1009) C1
      DO 25 N=1,NODT
   25 READ(15,1008) X(N*2-1),X(N*2),DU(N*2-1),DU(2*N)
      IF(NONC.NE.0) GO TO 88
      READ(15,1009) C1
      READ(15,1009) C1
      READ(15,1009) C1
      DO 22 I=1,NELE
   22 READ(15,1010) (UUN(I,J),J=1,4)
 1001 FORMAT(19X,A40) 
 1002 FORMAT(12X,I5,24X,I5,17X,I5,15X,I3,18X,I3)
 1004 FORMAT(52X,I5)
 1006 FORMAT(I10,F18.4,F15.6,F18.6,I18)     
 1007 FORMAT(I4,I9,7I5,I8,F12.7)
 1008 FORMAT(6X,2F15.6,39X,2E16.7)
 1009 FORMAT(A10)
 1010 FORMAT(6X,4E14.6)
 2001 FORMAT(/' START     TITLE = ',A40)
 2002 FORMAT(//10X,' STRESS AND DISPLACEMENT IN ',
     1   'TWO DIMENSIONAL FEM SOLUTION BY F2NSD '//
     2   '     TITLE = ',A40)
 2003 FORMAT(//'  ELEMENTS =',I5,'          VERTEX N',
     1   'ODES =',I5,'    TOTAL NODES =',I5,'    MAT',
     2   'ERIALS =',I3,'    GAUSS POINTS =',I3)
 2004 FORMAT(/'         NONC (NOT CONFORMAL = 0 ;',
     1   ' CONFORMAL =1) =',I5)
 2005 FORMAT(/' MATERIAL NO.   YOUNG''S RATIO    ',
     1   'POISSON''S RATIO    THICKNESS    ',
     2   'PLANESTRESS=0,PLANESTRAIN=1')
 2006 FORMAT(1H ,I9,F18.4,F15.6,F18.6,I18)
C
C  -------  CALCULATE STRESS AND DISPLACEMENT  ------
   88 CLOSE(15,STATUS='KEEP')
      OPEN(17,FILE='D1',STATUS='OLD')
      MOU(1,1)=0
      NS=0
   40 NS=NS+1 
      READ(17,1013,END=41) MOU(NS,1),MOU(NS,2),
     1    CO(NS,1),CO(NS,2)
      IF(MOU(NS,1).GE.90000) GO TO 41
      GO TO 40
   41 NS=NS-1
      IF(NS.EQ.0) IRR=90000
      WRITE(16,2011)
      DO 42 I2=1,NS
      N1=MOU(I2,1)
      N2=MOU(I2,2)
      IF(N1.LE.0) IRR=90000
      IF(N1.GT.NELE) IRR=90000
      IF(IRR.NE.0) GO TO 43
      IF(N2.LE.4000) GO TO 44
      M=N1
      MM=MV(9,N1)
      DO 47 II=1,8
      I3=MV(II,N1)
      DF(2*II-1)=DU(I3*2-1)
      DF(2*II)=DU(2*I3)
      DO 47 JJ=1,2
   47 XY(JJ+II*2-2)=X(I3*2-2+JJ)
      IF(N2.GT.8000) GO TO 32
      GZ=CO(I2,1)
      EA=CO(I2,2)
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 31
      WRITE(16,2020) N1,MM,N2,GZ,EA
      WRITE(16,2032) X1,X2,U1,U2
      GO TO 42
   31 WRITE(16,2013) N1,MM,N2,GZ,EA
      WRITE(16,2031) X1,X2,U1,U2,(SR(I),I=1,7)
      GO TO 42
   32 IF(N2.NE.8100) GO TO 49
      GZ=CO(I2,1)
      WRITE(16,2038) N1,MM,N2,GZ
      DO 51 LY=1,5
      EA=FLOAT(LY-3)*0.5
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 64
      WRITE(16,2018) GZ,EA
      WRITE(16,2032) X1,X2,U1,U2
      GO TO 51
   64 WRITE(16,2031) X1,X2,U1,U2,(SR(I),I=1,7)
   51 CONTINUE 
      GO TO 42
   49 EA=CO(I2,2)
      WRITE(16,2039) N1,MM,N2,EA
      DO 52 LX=1,5
      GZ=FLOAT(LX-3)*0.5
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 65
      WRITE(16,2018) GZ,EA
      WRITE(16,2032) X1,X2,U1,U2
      GO TO 52
   65 WRITE(16,2031) X1,X2,U1,U2,(SR(I),I=1,7)
   52 CONTINUE 
      GO TO 42
   44 IF(N2.LT.N1) IRR=90000
      IF(N2.GT.NELE) IRR=90000
      IF(IRR.NE.0) GO TO 43
      DO 35 M=N1,N2
      MM=MV(9,M)
      WRITE(16,2019) M,MM
      DO 33 II=1,8
      I3=MV(II,M)
      DF(2*II-1)=DU(I3*2-1)
      DF(2*II)=DU(2*I3)
      DO 33 JJ=1,2
   33 XY(JJ+II*2-2)=X(I3*2-2+JJ)
      DO 34 LX=1,3
      GZ=FLOAT(LX-2)
      DO 34 LY=1,3
      EA=FLOAT(LY-2)
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 67
      WRITE(16,2018) GZ,EA
      WRITE(16,2032) X1,X2,U1,U2
      GO TO 34
   67 WRITE(16,2031) X1,X2,U1,U2,(SR(I),I=1,7)
   34 CONTINUE
   35 CONTINUE
   42 CONTINUE
   43 WRITE(16,2014) IRR
 1013 FORMAT(2I5,2F10.5)
 2011 FORMAT(//'    H1 = MAXIMUM PRINCIPAL STRESS   ',
     1   ' H2 = MINIMUM PRINCIPAL STRESS    H3 = MAX',
     2   'IMUM SHEARING STRESS'/'    ANGLE = DIRECTIO',
     3   'N OF THE PRINCIPAL STRESS H1'/)
 2020 FORMAT(/'   ELEMENT =',I6,9X,'MATERIAL NO.=',I4,
     1   '   APPOINTMENT =',I6,'    GZAI =',F11.5,
     2   '    EATA =',F11.5/'   ---- ZERO DETERMINAN',
     3   'T JACOBIAN ----'/' COORDINATE X-Y   DISPLAC',
     4   'EMENT X-Y')
 2031 FORMAT(1H ,2F10.5,2E13.6,3F11.4,F8.2,3F11.4)
 2032 FORMAT(1H ,2F10.5,2E13.6)
 2013 FORMAT(/'   ELEMENT =',I6,9X,'MATERIAL NO.=',I4, 
     1   '   APPOINTMENT =',I6,'    GZAI =',F11.5,
     2   '    EATA =',F11.5/' COORDINATE X-Y   DISPLAC',
     3   'EMENT X-Y   PRINCIPAL STRESS H1-H2-H3   ANG',
     4   'LE   NORMAL STRESSX-Y   SHEARING STRESS XY')
 2038 FORMAT(/'   ELEMENT =',I6,9X,'MATERIAL NO.=',I4,
     1   '   APPOINTMENT =',I6,'   GZAI =',F11.5/
     2   ' COORDINATE X-Y   DISPLACEMENT X-Y   PRINCI',
     3   'PAL STRESS H1-H2-H3   ANGLE   NORMAL STRESS'
     4   ,'X-Y   SHEARING STRESS XY')
 2039 FORMAT(/'   ELEMENT =',I6,9X,'MATERIAL NO.=',I4,
     1   '   APPOINTMENT =',I6,'   EATA =',F11.5/
     2   ' COORDINATE X-Y   DISPLACEMENT X-Y   PRINCI',
     3   'PAL STRESS H1-H2-H3   ANGLE   NORMAL STRESS'
     4   ,'X-Y   SHEARING STRESS XY')
 2018 FORMAT(1H ,'    ---- ZERO DETERMINANT JACOBIAN ',
     1    '----       GZ-EA =',2F11.5)
 2019 FORMAT(/' ELEMENT =',I6,9X,'MATERIAL NO.=',I4/5X,
     2   ' COORDINATE X-Y   DISPLACEMENT X-Y   PRINCI',
     3   'PAL STRESS H1-H2-H3   ANGLE   NORMAL STRESS'
     4   ,'X-Y   SHEARING STRESS XY')
 2014 FORMAT(/1H ,'   IRR =',I6)
      CLOSE(16,STATUS='KEEP')
      CLOSE(17,STATUS='KEEP')
      STOP
      END
      SUBROUTINE TTT
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /A/RN22(8),H22(2,8),EE(3,3,300),BML(3,4),
     1          BMA(3,16),XGX(5),WGX(5),XY(16),SR(7),
     2          DF(16),UUN(4000,4),SSG(4000),EN(300),
     3          PR(300),GZ,EA,DET,X1,X2,U1,U2,NONC,M,
     4          MM,IDE,NGA,IRR
      DIMENSION DE(3)
      CALL GGG
      CALL FFF
      DO 602 I=1,3
      DE(I)=0.0
      DO 602 J=1,16
  602 DE(I)=DE(I)+BMA(I,J)*DF(J)
      IF(NONC.NE.0) GO TO 610
      DO 611 I=1,3
      DO 611 J=1,4
  611 DE(I)=DE(I)+BML(I,J)*UUN(M,J)
  610 DO 603 I=1,3
      SR(I+4)=0.0
      DO 603 J=1,3
  603 SR(I+4)=SR(I+4)+EE(I,J,MM)*DE(J)
      S4=SSG(M)*EN(MM)/(1.0-PR(MM))
      SR(5)=SR(5)-S4
      SR(6)=SR(6)-S4
      A1=(SR(5)-SR(6))*0.5
      B1=-SR(7)
      SR(3)=SQRT(A1**2+B1**2)
      SR(1)=(SR(5)+SR(6))*0.5+SR(3)
      SR(2)=(SR(5)+SR(6))*0.5-SR(3)
      IF (DABS(A1).LT.0.00001) GO TO 609
      FUV=ATAN(B1/A1)
      IF (A1.GT.0.0) GO TO 608
      FUV=FUV+3.141593
      IF (B1.LT.0.0) FUV=FUV-6.283185
      GO TO 608
  609 FUV=1.570796
      IF (B1.LT.0.0) FUV=FUV-3.141593
      IF (DABS(B1).LT.0.00001) FUV=0.0
  608 SR(4)=-FUV*90.0/3.141593
      X1=0.0
      X2=0.0
      U1=0.0
      U2=0.0
      DO 604 I=1,8
      U1=U1+RN22(I)*DF(2*I-1)
      U2=U2+RN22(I)*DF(2*I)
      X1=X1+RN22(I)*XY(I*2-1)
  604 X2=X2+RN22(I)*XY(2*I)
      IF(NONC.NE.0) GO TO 614
      U1=U1+(1.0-GZ*GZ)*GZ*UUN(M,1)+(1.0-EA*EA)*EA*UUN(M,2)
      U2=U2+(1.0-GZ*GZ)*GZ*UUN(M,3)+(1.0-EA*EA)*EA*UUN(M,4)
  614 CONTINUE
      RETURN
      END
      SUBROUTINE GGG
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /A/RN22(8),H22(2,8),EE(3,3,300),BML(3,4),
     1          BMA(3,16),XGX(5),WGX(5),XY(16),SR(7),
     2          DF(16),UUN(4000,4),SSG(4000),EN(300),
     3          PR(300),GZ,EA,DET,X1,X2,U1,U2,NONC,M,
     4          MM,IDE,NGA,IRR
      GZP=1.0+GZ
      EAP=1.0+EA
      GZM=1.0-GZ
      EAM=1.0-EA
      GZ2=1.0-GZ*GZ
      EA2=1.0-EA*EA
      RN22(1)=GZM*EAM*(-GZ-EA-1.0)/4.0
      RN22(2)=GZP*EAM*( GZ-EA-1.0)/4.0
      RN22(3)=GZP*EAP*( GZ+EA-1.0)/4.0
      RN22(4)=GZM*EAP*(-GZ+EA-1.0)/4.0
      RN22(5)=GZ2*EAM/2.0
      RN22(6)=GZP*EA2/2.0
      RN22(7)=GZ2*EAP/2.0
      RN22(8)=GZM*EA2/2.0
      H22(1,1)=EAM*(2.0*GZ+EA)/4.0
      H22(1,2)=EAM*(2.0*GZ-EA)/4.0
      H22(1,3)=EAP*(2.0*GZ+EA)/4.0
      H22(1,4)=EAP*(2.0*GZ-EA)/4.0
      H22(1,5)=-EAM*GZ
      H22(1,6)=EA2/2.0
      H22(1,7)=-EAP*GZ
      H22(1,8)=-EA2/2.0
      H22(2,1)=GZM*(2.0*EA+GZ)/4.0
      H22(2,2)=GZP*(2.0*EA-GZ)/4.0
      H22(2,3)=GZP*(2.0*EA+GZ)/4.0
      H22(2,4)=GZM*(2.0*EA-GZ)/4.0
      H22(2,5)=-GZ2/2.0
      H22(2,6)=-GZP*EA
      H22(2,7)=GZ2/2.0
      H22(2,8)=-GZM*EA
      RETURN
      END
      SUBROUTINE FFF
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /A/RN22(8),H22(2,8),EE(3,3,300),BML(3,4),
     1          BMA(3,16),XGX(5),WGX(5),XY(16),SR(7),
     2          DF(16),UUN(4000,4),SSG(4000),EN(300),
     3          PR(300),GZ,EA,DET,X1,X2,U1,U2,NONC,M,
     4          MM,IDE,NGA,IRR
      DIMENSION GJI(2,2),GH(2,8),GJ(2,2)
      DO 500 I=1,2
      DO 500 J=1,2
      GJ(I,J)=0.0
      DO 500 K=1,8
  500 GJ(I,J)=GJ(I,J)+H22(I,K)*XY(K*2-2+J)
      DET=GJ(1,1)*GJ(2,2)-GJ(1,2)*GJ(2,1)
      IF(DABS(DET).GT.1.E-09) GO TO 501
      IRR=40000+M
      IDE=IRR
      RETURN 
  501 GJI(1,1)=GJ(2,2)/DET
      GJI(2,1)=-GJ(2,1)/DET
      GJI(1,2)=-GJ(1,2)/DET
      GJI(2,2)=GJ(1,1)/DET
      DO 502 I=1,8
      DO 502 J=1,2
      GH(J,I)=0.0
      DO 502 K=1,2
  502 GH(J,I)=GH(J,I)+GJI(J,K)*H22(K,I)
      DO 503 I=1,3
      DO 503 J=1,16
  503 BMA(I,J)=0.0
      DO 504 J=1,8
      BMA(1,2*J-1)=GH(1,J)
      BMA(2,2*J)  =GH(2,J)
      BMA(3,2*J-1)=GH(2,J)
  504 BMA(3,2*J)  =GH(1,J)
      IF(NONC.NE.0) RETURN
      DO 506 I=1,2
      GH(I,1)=GJI(I,1)*(1.0-3.0*GZ*GZ)
  506 GH(I,2)=GJI(I,2)*(1.0-3.0*EA*EA)
      DO 505 I=1,3
      DO 505 J=1,4
  505 BML(I,J)=0.0
      DO 507 J=1,2
      BML(1,J)  =GH(1,J)
      BML(2,J+2)=GH(2,J)
      BML(3,J)  =GH(2,J)
  507 BML(3,J+2)=GH(1,J)
      RETURN
      END
